Name: coreutils
Version: 5.3.1
Release: alt0.4
%define snapshot 200504240446
%define srcname %name-%snapshot

Summary: The GNU versions of common management utilities
License: GPL
Group: System/Base
Url: http://www.gnu.org/software/%name/
Packager: Coreutils Development Team <coreutils@packages.altlinux.org>

# ftp://ftp.gnu.org/gnu/%name/
# cvs -d anoncvs@savannah.gnu.org:/cvsroot/coreutils export -Dnow coreutils
Source: %srcname.tar.bz2

# sources from fileutils
Source11: color_ls.sh
Source12: color_ls.csh

# sources from sh-utils
Source20: exit.S
Source21: getuseruid.c
Source22: realpath.c
Source23: runas.c
Source24: runbg.c
Source25: usleep.c
Source26: runas.1
Source27: usleep.1

# ALT patches, candidates for upstream version
# and CVS backports.
Patch1: coreutils-5.3.1-alt-hostname.patch

# patches from fileutils.
Patch11: fileutils-4.1.11-rh-owl-install-C.patch
Patch12: coreutils-5.3.0-rh-owl-ls_default_time_style.patch

# ALT specific.
Patch101: coreutils-5.3.0-alt-texinfo.patch
Patch102: coreutils-5.3.0-alt-mksock.patch
Patch103: coreutils-5.3.1-alt-dircolors.patch
Patch104: coreutils-5.3.0-alt-without-su-uptime.patch
Patch105: coreutils-5.3.1-alt-ls_dir_vdir.patch
Patch106: coreutils-5.3.0-alt-posix2_version.patch

# other.
Patch202: coreutils-5.2.0-rh-install_strip.patch
Patch203: coreutils-5.3.1-rh-owl-alt-ls_dumbterm.patch
Patch204: coreutils-4.5.3-rh-langinfo.patch
Patch205: coreutils-5.2.0-rh-alt-ls-stat.patch

Provides: /bin/cat /bin/cut /bin/du /bin/head /bin/hostname /bin/install
Provides: /bin/mkfifo /bin/readlink /bin/sort /bin/tail /bin/wc
Provides: /sbin/chroot
Provides: %_bindir/mksock %_bindir/realpath

Provides: stat = %version, fileutils = %version, textutils = %version, sh-utils = %version
Obsoletes: stat, fileutils, textutils, sh-utils
Conflicts: man-pages < 0:1.52-alt2, initscripts < 0:5.49-ipl41mdk, rpm-build < 0:4.0.4-alt7
# due to /bin/kill
Conflicts: util-linux < 0:2.12-alt1
# due to /usr/bin/kill and %_man1dir/kill.1
Conflicts: procps < 0:2.0.10-alt4
# due to incompatible change in "readlink -f"
Conflicts: chrooted < 0:0.3.1-alt1
# due to buggy rpmdups/rpmrdups
Conflicts: rpm-utils < 0:0.7.6-alt1
# due to hostname
Conflicts: net-tools < 0:1.60-alt9

Requires(post): %install_info
Requires(preun): %uninstall_info

# due to autopoint
BuildPreReq: cvs

# Automatically added by buildreq on Tue Jun 03 2003
BuildRequires: libtinfo-devel

%description
These are the GNU core utilities.  This package is the union of
the GNU fileutils, sh-utils, and textutils packages.

These tools are the GNU versions of common useful and popular
file and text utilities which are used for:
+ file management
+ shell scripting
+ modifying text file

Most of these programs have significant advantages over their Unix
counterparts, such as greater speed, additional options, and fewer
arbitrary limits.

%prep
%setup -q -n %srcname

# ALT patches, candidates for upstream version
# and CVS backports.
%patch1 -p1

# patches from fileutils.
#FIXME#%patch11 -p1
%patch12 -p1

# ALT specific.
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1

# other.
%patch202 -p1
%patch203 -p1
%patch204 -p1
#FIXME#%patch205 -p1

find -type f -name \*.orig -delete -print

# 2nd part of the posix2_version patch
find src -type f -print0 |
	xargs -r0 %__grep -FZl 'posix2_version () < 200112' -- |
	xargs -r0 %__subst -p 's/posix2_version () < 200112/posix2_version_lt_200112 ()/' --
find src -type f -print0 |
	xargs -r0 %__grep -FZl '200112 <= posix2_version ()' -- |
	xargs -r0 %__subst -p 's/200112 <= posix2_version ()/posix2_version_ge_200112 ()/' --

# Get rid of su and uptime.
%__rm -fv {src,man}/{su,uptime}.*

# begin HACK
%__subst 's/dist_man_MANS/man_MANS/g' man/Makefile.am
# end HACK

# Fix docs: it should say /var/run/[uw]tmp not /etc/[uw]tmp
%__grep -Zl /etc/[uw]tmp doc/* man/* |
	xargs -r0 %__subst -p 's,/etc/utmp,/var/run/utmp,g;s,/etc/wtmp,/var/log/wtmp,g'

%__rm -f doc/*.info* man/*.1

%build
autoreconf -fisv -I m4

# hack to disable uptime build.
export gnulib_cv_have_boot_time=no

%configure --exec-prefix=/
%make_build

#VERBOSE=yes
%{?!__buildreqs:%{?!_without_check:%{?!_disable_check:%make_build -k check}}}

# Build assembler version of true and false.
gcc -nostartfiles -nodefaultlibs -nostdlib "$RPM_SOURCE_DIR"/exit.S -DSTATUS=0 -o true
gcc -nostartfiles -nodefaultlibs -nostdlib "$RPM_SOURCE_DIR"/exit.S -DSTATUS=1 -o false

# Build additional utilities.
for n in getuseruid realpath runas runbg usleep; do
	gcc $RPM_OPT_FLAGS "$RPM_SOURCE_DIR/$n.c" -o $n
done

bzip2 -9fk ChangeLog NEWS THANKS

%install
%makeinstall
%__install -pD -m644 src/dircolors.hin "$RPM_BUILD_ROOT%_sysconfdir/DIR_COLORS"

pushd "$RPM_BUILD_ROOT"
	%__mkdir_p bin
	
	# %_bindir -> /bin relocations
        for n in \
		basename cat chgrp chmod chown cp cut date dd df du echo \
		false head hostname install kill link ln ls mkdir mkfifo \
		mknod mv nice pwd readlink rm rmdir sleep sort stty sync \
		tail touch true uname unlink wc \
	; do
		%__mv .%_bindir/$n bin/
	done

	# dir and vdir now symlinks to ls
	%__ln_s -nf ../../bin/ls .%_bindir/dir
	%__ln_s -nf ../../bin/ls .%_bindir/vdir

	# compatibility symlinks
	for n in cat cut du head install kill mkfifo sort tail wc; do
		%__ln_s ../../bin/$n .%_bindir/
	done

	# test
	%__ln_s -nf test .%_bindir/[

	# chroot
	%__mkdir_p sbin .%_sbindir
	%__mv .%_bindir/chroot sbin/
		%__ln_s ../../sbin/chroot .%_sbindir/

	# hostname
	for n in dnsdomainname domainname nisdomainname ypdomainname; do
		%__ln_s hostname ./bin/$n
		%__ln_s hostname.1 ./%_man1dir/$n.1
	done

	%__mkdir_p .%_sysconfdir/profile.d
	%__install -pm755 %SOURCE11 %SOURCE12 .%_sysconfdir/profile.d/
	%__ln_s ../../bin/install .%_bindir/ginstall
popd

# Install assembler versions of true and false.
%__install -p -m755 true false "$RPM_BUILD_ROOT/bin/"

# Install additional utilities and its manpages.
%__install -p -m755 getuseruid runas usleep $RPM_BUILD_ROOT/bin/
%__install -p -m755 realpath runbg $RPM_BUILD_ROOT%_bindir/
%__install -p -m644 $RPM_SOURCE_DIR/{runas,usleep}.1 $RPM_BUILD_ROOT%_man1dir/

%find_lang %name

%pre
# Remove info pages from fileutils, textutils and sh-utils.
for f in %_infodir/{fileutils,textutils,sh-utils}.info*; do
	[ -f "$f" ] || continue
	RPM_INSTALL_ARG1=0 %_sbindir/uninstall_info "$f" ||:
done

%post
%install_info %name.info

%preun
%uninstall_info %name.info

%files -f %name.lang
%config(noreplace) %_sysconfdir/DIR_COLORS
%config(noreplace) %_sysconfdir/profile.d/*
/bin/*
%_bindir/*
/sbin/*
%_sbindir/*
%_mandir/man?/*
%_infodir/*.info*
%doc ChangeLog.bz2 NEWS.bz2 THANKS.bz2 AUTHORS README TODO

%changelog
* Mon Apr 25 2005 Dmitry V. Levin <ldv@altlinux.org> 5.3.1-alt0.4
- Updated to 5.3.1 snapshot 200504240446.
- Updated mksock and ls_dir_vdir patches to use
  program_invocation_short_name instead of __progname.

* Wed Apr 13 2005 Dmitry V. Levin <ldv@altlinux.org> 5.3.1-alt0.3
- Updated to 5.3.1 snapshot 200504120741.

* Mon Apr 11 2005 Dmitry V. Levin <ldv@altlinux.org> 5.3.1-alt0.2
- Relocated chroot utility from %_sbindir to /sbin.
- Packaged hostname(1) (#6360).
- Patched hostname(1) to be somewhat compatible with
  traditional hostname utility from net-tools package.

* Mon Apr 04 2005 Dmitry V. Levin <ldv@altlinux.org> 5.3.1-alt0.1
- Updated to 5.3.1 snapshot 200504010740.
- tee: do not close stdout more than once.

* Tue Jan 11 2005 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt1
- Updated to 5.3.0 snapshot 200501082045 (release).

* Sun Jan 02 2005 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.10
- Updated to 5.3.0 snapshot 200412311006.

* Sat Nov 20 2004 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.9
- Updated to 5.3.0 snapshot 200411200857.

* Mon Nov 01 2004 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.8
- Updated to 5.3.0 snapshot 200410292210.

* Sun Oct 17 2004 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.7
- Updated to 5.3.0 snapshot 200410151932.

* Thu Sep 30 2004 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.6
- Updated to 5.3.0 snapshot 200409280634.

* Tue Aug 24 2004 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.5
- Updated to 5.3.0 snapshot 200408240736.

* Mon Aug 23 2004 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.4
- Updated to 5.3.0 snapshot 200408200229.

* Fri Aug 13 2004 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.3
- chown: Fixed USER.GROUP bug.

* Thu Aug 12 2004 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.2
- Updated to 5.3.0 snapshot 200408112347.
- install: Fixed one more regression.
- exit.S: Added x86_64 support.

* Tue Aug 10 2004 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.1
- Updated to 5.3.0 snapshot 200408100654.
- Merged upstream: 7 patches.
- Reworked patches.
- install: Fixed two regressions.

* Thu Jun 03 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.1-alt5
- Fixed canonicalize_file_name behaviour.
- Changed default behaviour for chown/chgrp.

* Sun Apr 25 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.1-alt4
- Backported "stty -iutf8" option support.
  Requires quite fresh glibc-devel package at build time.

* Sun Apr 04 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.1-alt3
- readlink: implemented more canonicalize options.

* Wed Mar 31 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.1-alt2
- Assorted backports from cvs head.
- Package /bin/kill, %_bindir/kill and its manpage from coreutils.

* Sat Mar 13 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.1-alt1
- Updated to 5.2.1
- Merged upstream patches:
  eggert-chown-lsb
  alt-cloexec

* Tue Mar 02 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.0-alt2
- chown: applied patch from Paul Eggert, see
  http://mail.gnu.org/archive/html/bug-coreutils/2004-02/msg00125.html
- nohup: fixed nasty fd leak.

* Mon Feb 23 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.0-alt1
- Updated to 5.2.0, reviewed patches.
- Merged upstream patches:
  alt-owl-chown
- Removed obsolete patches:
  rh-CLOCK_REALTIME
  rh-df_spacedir
  rh-mem
  rh-utmp
- Added RH patches:
  rh-afs
  rh-langinfo
  rh-allow_old_options
  rh-alt-ls-stat
- Use tweaked help2man from this package for manpage generation.
- Do not build and package rm-static.

* Tue Jun 03 2003 Dmitry V. Levin <ldv@altlinux.org> 5.0-alt3
- Fixed file descriptor leakage in du (Jim Meyering).
- Build statically linked version of the GNU rm program
  and package it into rm-static subpackage.

* Fri May 02 2003 Dmitry V. Levin <ldv@altlinux.org> 5.0-alt2
- Regenerated manpages with help2man-1.29-alt2.
- Ported %%pre script to new uninstall_info.

* Sun Apr 06 2003 Dmitry V. Levin <ldv@altlinux.org> 5.0-alt1
- Updated to 5.0

* Mon Mar 31 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.12-alt1
- Updated to 4.5.12

* Thu Mar 20 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.11-alt1
- Updated to 4.5.11

* Fri Mar 14 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.10-alt1
- Updated to 4.5.10

* Wed Mar 05 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.9-alt1
- Updated to 4.5.9

* Sat Feb 22 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.8-alt1
- Updated to 4.5.8

* Mon Feb 10 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.7-alt1
- Updated to 4.5.7
- Updated patches:
  + alt-texinfo

* Thu Feb 06 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.6-alt1
- Updated to 4.5.6
- Merged upstream patches:
  + alt-who_xmalloc_fix
- Updated patches:
  + alt-texinfo

* Tue Feb 04 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.5-alt1
- Updated to 4.5.5
- Merged upstream patches:
  + alt-xalloc
  + alt-xgetcwd
  + alt-canonicalize
  + alt-readlink
  + alt-owl-rh-ls_restore_color
- New patches:
  + alt-xalloc
- Updated patches:
  + alt-mksock
  + alt-without-hostname-su-uptime

* Tue Feb 04 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.3-alt3
- who: fixed memory allocation arithmetic (#0002149).

* Sun Dec 01 2002 Dmitry V. Levin <ldv@altlinux.org> 4.5.3-alt2
- Removed automake patch (no longer needed with automake >= 1.7).
- Minor code cleanups (xalloc and xgetcwd).
- Added canonicalize_file_name implementation to libfetish;
  affects non-glibc platforms.
- Turned dir and vdir into symlinks to ls (#0001635).
- Updated dircolors.
- Removed obsolete (merged) patches:
  sh-utils-2.0-rh-rfc822
- Removed obsolete (not applied) patches:
  fileutils-4.0.38-alt-cp_deref_always
  fileutils-4.1-alt-cp_force_ignore
- Rediffed patches:
  rh-df_spacedir
  rh-install_strip
  rh-owl-alt-ls_dumbterm
  rh-CLOCK_REALTIME
  alt-owl-chown
- Corrected description.

* Thu Oct 31 2002 Dmitry V. Levin <ldv@altlinux.org> 4.5.3-alt1
- Updated to 4.5.3
- Our "ln --target-dir" fix merged upstream.

* Sun Oct 13 2002 Dmitry V. Levin <ldv@altlinux.org> 4.5.2-alt2
- Minor specfile tweaks.
- Updated buildrequires.

* Tue Oct 08 2002 Dmitry V. Levin <ldv@altlinux.org> 4.5.2-alt1
- Updated to 4.5.2
- Disabled cp_deref_always patch.
- Enabled tests by default.
- Fixed "ln --target-dir" (#0001369).

* Thu Sep 26 2002 Stanislav Ievlev <inger@altlinux.ru> 4.5.1-alt2
- Ressurected Conflicts.

* Tue Sep 17 2002 Stanislav Ievlev <inger@altlinux.ru> 4.5.1-alt1
- Inital build for ALT. This package is the union of the
  fileutils, sh-utils, and textutils packages.
- Review patches:
  + dropped "rh-stoneage" patch;
  + adopted readlink and mksock patches;
  + disabled "force interactive" patch.
